#ifndef STA_CORE_UART_SETTINGS_HPP
#define STA_CORE_UART_SETTINGS_HPP

#include <stdint.h>

/**
 * @defgroup sta_core_uart UART
 * @ingroup sta_core
 * @brief UART interface.
 */


namespace sta
{
    /**
     * @brief UART modes of operation.
     */
    enum class UARTMode
    {
        RX,
        TX,
        RX_TX
    };

    /**
     * @brief UART settings.
     */
    struct UARTSettings
    {
        /// @brief Mode of operation. 
        UARTMode mode;
    };
} // namespace sta

#endif // STA_CORE_UART_SETTINGS_HPP
